/***************************************************************************
                                 actor-destructible.h
                             -------------------
    begin                : Fri May 26 2000
    copyright            : (C) 2000 by Bytopia Software
    email                : lancekt@wam.umd.edu
                             -------------------
 An actor with hit points and a death animation.
 ***************************************************************************/

#ifndef ACTOR_DESTRUCTIBLE_H
#define ACTOR_DESTRUCTIBLE_H

#include "actor.h"



class ActorDestructible : public Actor {
	private:
		int hit_points;
		bool hurt_as_player, hurt_as_enemy;
		Anim *idle_anim;
		Anim *death_anim;
		
		Behavior *death_behavior;
	protected:
		bool dead;
	public:
		ActorDestructible();
		virtual ~ActorDestructible();
		
		virtual ActorSignal update();
		
		virtual ActorSignal collided();
		virtual void get_signal(ActorSignal signal);
		
		void set_hp(int hp);
		void hurt(int hp);
		void heal(int hp);
		void kill();
		int get_hp();
		
		void set_hurt_types(bool players, bool enemies);
		bool gets_hurt_as_player();
		bool gets_hurt_as_enemy();
		
		void set_death_anim(Anim *new_anim);
		void set_idle_anim(Anim *new_anim);
		Anim *get_death_anim();
		Anim *get_idle_anim();
		void set_death_behavior(Behavior *new_death_behavior);
		Behavior *get_death_behavior();
};



#endif

