/***************************************************************************
                                 actor-player.h
                             -------------------
    begin                : Sat May 27 2000
    copyright            : (C) 2000 by Bytopia Software
    email                : lancekt@wam.umd.edu
                             -------------------
 ***************************************************************************/

#ifndef ACTOR_PLAYER_H
#define ACTOR_PLAYER_H

#define NUM_WEAPONS 3
#define PLAYER_YELP_DELAY 10

#include <string>

#include "actor-destructible.h"
#include "behavior-from-keyboard.h"
#include "behavior-quadratic.h"
#include "event.h"
#include "actorlist.h"
#include "bullet-firebolt.h"
#include "bullet-lightning.h"
#include "bullet-minibolt.h"
#include "enemy.h"

#define WEAPON_SWITCH_SPEED 10



enum facing_t {
	demon_backward, demon_forward
};

class ActorPlayer : public ActorDestructible{
	private:
		Anim *backward_anim;
		Anim *backward_shoot_anim;
		Anim *backward_blue_anim;
		Anim *backward_super_shoot_anim;
		Anim *backward_super_blue_anim;
		Anim *forward_anim;
		Anim *wings_anim;
		Anim *forward_shoot_anim;
		Anim *forward_blue_anim;
		Anim *forward_super_shoot_anim;
		Anim *forward_super_blue_anim;
		Anim *fore_to_back_anim;
		Anim *back_to_fore_anim;
		int to_next_shot[NUM_WEAPONS + 1];
		int to_next_weapon_switch;
		int to_next_yelp;
		int weapon_power[NUM_WEAPONS + 1];
		char *weapon_name[NUM_WEAPONS + 1];
		int current_weapon;
		bool attack_in_progress;
		unsigned long score;
		facing_t facing;
	public:
		ActorPlayer(Event *event = NULL);
		~ActorPlayer();
		
		virtual ActorSignal update();
		virtual void paint();
		
		virtual void get_signal(ActorSignal signal);
		
		void fire();
		
		int get_score();
		void add_to_score(int points);
		void set_score(long int points);
		
		int get_current_weapon();
		void set_weapon_power(int weapon, int level);
		int get_weapon_power(int weapon);
		char *get_weapon_name(int weapon);

		bool is_alive();	
	private:
		void prev_weapon();
		void next_weapon();
};

#endif

