/***************************************************************************
                                 actorlist.h
                             -------------------
    begin                : Sat May 27 2000
    copyright            : (C) 2000 by Bytopia Software
    email                : lancekt@wam.umd.edu
                             -------------------
	A list of actors.
 ***************************************************************************/

#ifndef ACTORLIST_H
#define ACTORLIST_H

#include <iostream>

#include "actor.h"



class ActorList {
	private:
		struct node {
			Actor *actor;
			bool exists_outside_list;
			node *next;
		};
		node *first;
		int node_count;
	public:
		ActorList();
		~ActorList();
		
		void update();
		void paint();
		
		void add_actor(Actor *actor);				// the actor will be deallocated upon removal from list
		void register_actor(Actor *actor);	// the actor will not be deallocated
		
		int get_actor_count();
		
		void debug_dump(std::ostream &out);
	
	private:
		void check_collisions(node *check_node);		// called by update().  Checks check_node for collisions
																								// with all nodes following it.  (Meaning it has to be
																								// called sequentially for every node in the list.)
		void add_node(node *new_node);
		void remove_node(node *dead_node);
		void deallocate_node(node *dead_node);
};



#endif

