/***************************************************************************
                                audiocache.h
                             -------------------
    begin                : Fri Jun 2 2000
    copyright            : (C) 2000 by Bytopia Software
    email                : lancekt@wam.umd.edu
 ***************************************************************************/


#ifndef AUDIOCACHE_H
#define AUDIOCACHE_H

#include <iostream>
#include <fstream>
#include <string.h>
#include <SDL/SDL.h>
#include <SDL/SDL_mixer.h>



class AudioCache {
	private:
		struct node {
			Mix_Chunk *data;
			char *tag;
			node *next;
		};
		node *first;

	public:
		AudioCache();
		~AudioCache();
		void clear();
		void add_sound_from_file(char *file, char *new_tag);
		void remove_sound(char *dead_tag);
		Mix_Chunk *get_sound(char *search_tag);
		
		void load_sounds_from_list_file(char *filename);

		void debug_dump(std::ostream &out);

	private:
		node *find_node(char *search_tag);
		void add_node(node *new_node);
		void remove_node(node *dead_node);
};

#endif
