
#include "background.h"



Display *Background::display = NULL;



Background::Background()
{
	image_name = NULL;
	position = 0;
	width = 0;
}



Background::~Background()
{
	if (image_name != NULL) delete [] image_name;
}



void Background::set_image(char *new_image_name)
{
	BoundingBox temp;

	if (image_name != NULL) delete [] image_name;
	
	image_name = new char[strlen(new_image_name) + 1];
	strcpy(image_name, new_image_name);
	
	temp = display->get_sprite_dimensions(image_name);
	width = temp.get_width();
}



void Background::paint()
{
	if (display != NULL) {
	 // display->paint_sprite((int)position, 0, image_name, NULL, 320, 240);
	  display->paint_sprite((int)position, 0, image_name);
	} else {
		std::cerr << "WARNING: tried to paint a background before binding a display" << std::endl;
	}
}



void Background::bind_display(Display *new_display)
{
	display = new_display;
}



void Background::scroll(float amount)
{
	if (-position < (width - display->get_width()))
		position -= amount;
}



float Background::get_position()
{
	return position;
}

