
#include "behavior-follow.h"



BehaviorFollow::BehaviorFollow()
{
	x_impulse = BEHAVIOR_FOLLOW_DEFAULT_IMPULSE;
	y_impulse = BEHAVIOR_FOLLOW_DEFAULT_IMPULSE;
	dx_max = BEHAVIOR_FOLLOW_DEFAULT_D_MAX;
	dy_max = BEHAVIOR_FOLLOW_DEFAULT_D_MAX;
}



void BehaviorFollow::set_impulse(float new_x, float new_y)
{
	x_impulse = new_x;
	y_impulse = new_y;
}



void BehaviorFollow::set_speed_maxima(float new_x, float new_y)
{
	dx_max = new_x;
	dy_max = new_y;
}



void BehaviorFollow::set_target(Actor *new_target)
{
	target = new_target;
}



char *BehaviorFollow::update(int &ret_x, int &ret_y)
{
	if (target != NULL) {
		if (target->get_x() < get_x())
			set_dx(get_dx() - x_impulse);
		if (target->get_x() > get_x())
			set_dx(get_dx() + x_impulse);
		if (target->get_y() < get_y())
			set_dy(get_dy() - y_impulse);
		if (target->get_y() > get_y())
			set_dy(get_dy() + y_impulse);
	} else {
		std::cerr << "WARNING: tried to update a BehaviorFollow without a target" << std::endl;
	}
	if (get_dx() > dx_max) set_dx(dx_max);
	if (get_dx() < -dx_max) set_dx(-dx_max);
	if (get_dy() > dy_max) set_dy(dy_max);
	if (get_dy() < -dy_max) set_dy(-dy_max);
	update_linear();
	ret_x = get_x();
	ret_y = get_y();
	return "";
}

