/***************************************************************************
                           behavior-from-keyboard.h
                             -------------------
    begin                : Fri May 26 2000
    copyright            : (C) 2000 by Bytopia Software
    email                : lancekt@wam.umd.edu
                             -------------------
	A Behavior that responds to input from the keyboard.  Must be bound to an
	Event before use.
 ***************************************************************************/

#ifndef BEHAVIOR_FROM_KEYBOARD_H
#define BEHAVIOR_FROM_KEYBOARD_H

#define BEHAVIOR_FROM_KEYBOARD_DEFAULT_X_IMPULSE 1
#define BEHAVIOR_FROM_KEYBOARD_DEFAULT_Y_IMPULSE 1
#define BEHAVIOR_FROM_KEYBOARD_DEFAULT_X_INERTIA .3
#define BEHAVIOR_FROM_KEYBOARD_DEFAULT_Y_INERTIA .3
#define BEHAVIOR_FROM_KEYBOARD_DEFAULT_DX_MAX 6
#define BEHAVIOR_FROM_KEYBOARD_DEFAULT_DY_MAX 6
#define BEHAVIOR_FROM_KEYBOARD_DEFAULT_XMIN 0
#define BEHAVIOR_FROM_KEYBOARD_DEFAULT_YMIN 0
#define BEHAVIOR_FROM_KEYBOARD_DEFAULT_XMAX 320
#define BEHAVIOR_FROM_KEYBOARD_DEFAULT_YMAX 240

#include "behavior-linear.h"
#include "event.h"



class BehaviorFromKeyboard : public BehaviorLinear {
	private:
		Event *event_handler;
		float x_impulse, y_impulse;
		float x_inertia, y_inertia;
		float dx_max, dy_max;
		float x_min, y_min, x_max, y_max;
	public:
		BehaviorFromKeyboard();
		
		void bind_event_handler(Event *new_event);
		
		virtual char *update(int &ret_x, int &ret_y);
		
		void set_impulse(float new_x, float new_y);
		void set_inertia(float new_x, float new_y);
		void set_maxima(float new_x, float new_y);
		void set_bounds(int new_xmin, int new_ymin, int new_xmax, int new_ymax);
};


#endif

