
#include "behavior-periodic.h"



BehaviorPeriodic::BehaviorPeriodic()
{
	period = 1;
	to_next_fire = 0;
	signal = new char[5];
	strcpy(signal, "fire");
	background_behavior = NULL;
}



BehaviorPeriodic::~BehaviorPeriodic()
{
	delete [] signal;
	if (background_behavior != NULL) delete background_behavior;
}



void BehaviorPeriodic::set_signal(char *new_signal)
{
	delete [] signal;
	signal = new char[strlen(new_signal) + 1];
	strcpy(signal, new_signal);
}



void BehaviorPeriodic::set_period(int new_period)
{
	period = new_period;
	to_next_fire = 0;
}



char *BehaviorPeriodic::update(int &ret_x, int &ret_y)
{
	if (background_behavior != NULL)
		background_behavior->update(ret_x, ret_y);
	else {
		ret_x = get_x();
		ret_y = get_y();	
	}		
	to_next_fire++;
	if (to_next_fire >= period) {
		to_next_fire = 0;
		return signal;
	}
	return "";
}



void BehaviorPeriodic::set_background_behavior(Behavior *new_bb)
{
	new_bb->set_position(get_x(), get_y());
	background_behavior = new_bb;
}

