/***************************************************************************
                                 behavior-quadratic.h
                             -------------------
    begin                : Fri May 26 2000
    copyright            : (C) 2000 by Bytopia Software
    email                : lancekt@wam.umd.edu
                             -------------------
	A behavior representing quadratic movement.
 ***************************************************************************/

#ifndef BEHAVIOR_QUADRATIC_H
#define BEHAVIOR_QUADRATIC_H

#include "behavior-linear.h"



class BehaviorQuadratic : public BehaviorLinear {
	private:
		float d2x, d2y;
	public:
		BehaviorQuadratic();
		
		virtual char *update(int &ret_x, int &ret_y);
		
		virtual void reset();
		virtual void reset(const int new_x, const int new_y);

		float get_d2x();
		float get_d2y();
				
		void set_d2x(const float new_d2x);
		void set_d2y(const float new_d2y);
	protected:
		void update_quadratic();
};



#endif

