/***************************************************************************
                             behavior-sinewave.h
                             -------------------
    begin                : Wed May 31 2000
    copyright            : (C) 2000 by Bytopia Software
    email                : lancekt@wam.umd.edu
                             -------------------
	Movement along a sine curve.  A clever trick to avoid using any actual trig
	functions.  Is it an actual sine curve?  Who cares?  It works.  You should
	also give this a dx value if you want it to move horizontally.  :)
 ***************************************************************************/

#ifndef BEHAVIOR_SINEWAVE_H
#define BEHAVIOR_SINEWAVE_H

#define BEHAVIOR_SINEWAVE_DEFAULT_IMPULSE .2
#define BEHAVIOR_SINEWAVE_DEFAULT_BASELINE 100
#define BEHAVIOR_SINEWAVE_DEFAULT_DX -1

#include "behavior-linear.h"



class BehaviorSineWave : public BehaviorLinear {
	private:
		float baseline;
		float impulse;
	public:
		BehaviorSineWave();
		
		virtual char *update(int &ret_x, int &ret_y);
		
		void set_baseline(float new_baseline);
		void set_impulse(float new_impulse);	
};










#endif
