/***************************************************************************
                                 behavior.h
                             -------------------
    begin                : Thu May 25 2000
    copyright            : (C) 2000 by Bytopia Software
    email                : lancekt@wam.umd.edu
                             -------------------
	An abstract base class for types of movement.
	TODO:	-	make Update() return some kind of value that will be interpreted
					by the actor running it.  (For example, if the Actor should spawn
					a particle at a certain point in the path.)
 ***************************************************************************/

#ifndef BEHAVIOR_H
#define BEHAVIOR_H

#include <iostream>



class Behavior {
	private:
		float x, y;
	public:
		Behavior();
		virtual ~Behavior();
		
		virtual char *update(int &ret_x, int &ret_y);					// ret_x and ret_y get the new
																													// position
		virtual void reset();
		virtual void reset(const int new_x, const int new_y);
		
		void set_position(const int new_x, const int new_y);
		void set_position(const float new_x, const float new_y);
		void get_position(int &ret_x, int &ret_y);		
		void set_x(const int new_x);
		void set_y(const int new_y);
		int get_x();
		int get_y();
		float get_full_x();
		float get_full_y();
};



#endif

