
#include "boundingbox.h"



BoundingBox::BoundingBox()
{
	x1 = 0;
	y1 = 0;
	x2 = 0;
	y2 = 0;
}



BoundingBox::~BoundingBox()
{
}



void BoundingBox::set(int x1_new, int y1_new, int x2_new, int y2_new)
{
	x1 = x1_new;
	y1 = y1_new;
	x2 = x2_new;
	y2 = y2_new;
}



void BoundingBox::get(int &x_1, int &y_1, int &x_2, int &y_2)
{
	x_1 = x1;
	y_1 = y1;
	x_2 = x2;
	y_2 = y2;
}



bool BoundingBox::is_contained_in(BoundingBox container)
{
	if ((x1 >= container.x1) && (y1 >= container.y1) && (x2 <= container.x2) && (y2 <= container.y2))
		return true;
	return false;
}



bool BoundingBox::contains(BoundingBox contained)
{
	if (contained.is_contained_in(*this))
		return true;
	return false;
}



bool BoundingBox::collides_with(const BoundingBox &bbox)
{
	if (((bbox.x1 >= x1) && (bbox.x1 <= x2)) || ((x1 >= bbox.x1) && (x1 <= bbox.x2))) {
		if (((bbox.y1 >= y1) && (bbox.y1 <= y2)) || ((y1 >= bbox.y1) && (y1 <= bbox.y2))) {
//			std::cerr << "Collision!" << std::endl;
			return true;
		}
	}
	return false;
}



void BoundingBox::debug_dump(std::ostream &out)
{
	out << "BoundingBox: (" << x1 << "," << y1 << ")-(" << x2 << "," << y2 << ")" << std::endl;
}



BoundingBox BoundingBox::operator+(const BoundingBox bbox)
{
	BoundingBox ret;
	ret.x1 = x1 + bbox.x1;
	ret.y1 = y1 + bbox.y1;
	ret.x2 = x2 + bbox.x2;
	ret.y2 = y2 + bbox.y2;
	return ret;
}



int BoundingBox::get_width()
{
	return (x2 - x1);
}



int BoundingBox::get_height()
{
	return (y2 - y1);
}



bool BoundingBox::is_empty()
{
	if (x1 == 0 || y1 == 0 || x2 == 0 || y2 == 0)
		return true;
	return false;
}

