/***************************************************************************
                                boundingbox.h
                             -------------------
    begin                : Fri May 26 2000
    copyright            : (C) 2000 by Bytopia Software
    email                : lancekt@wam.umd.edu
                             -------------------
	A class that represents an object's bounding box.
 ***************************************************************************/

#ifndef BOUNDING_BOX_H
#define BOUNDING_BOX_H

#include <iostream>



class BoundingBox {
	private:
		int x1, y1, x2, y2;
	public:
		BoundingBox();
		~BoundingBox();
		
		bool is_contained_in(const BoundingBox container);
		bool contains(const BoundingBox contained);
		
		bool collides_with(const BoundingBox &bbox);
		
		BoundingBox operator+(const BoundingBox bbox);
		
		void set(int x1_new, int y1_new, int x2_new, int y2_new);
		void get(int &x_1, int &y_1, int &x_2, int &y_2);
		
		int get_width();
		int get_height();
		
		bool is_empty();
		
		void debug_dump(std::ostream &out);
};




#endif
