/***************************************************************************
                                 display.h
                             -------------------
    begin                : Thu May 25 2000
    copyright            : (C) 2000 by Bytopia Software
    email                : lancekt@wam.umd.edu
                             -------------------
	A class representing the video memory and screen.  This version uses SDL
	for its interaction with the video hardware.
	Only one Display can be instantiated at a time; the program will exit with
	an error if you try to instantiate more than one.
	TODO:	- Add some kind of mechanism for drawing backgrounds?
 ***************************************************************************/

#ifndef DISPLAY_H
#define DISPLAY_H

#include <iostream>
#include <SDL/SDL.h>

#include "imagecache.h"
#include "boundingbox.h"
#include "font.h"



class Display {
	private:
		int w, h, depth;
		SDL_Surface *screen;//, *buffer;
		ImageCache *cache;
		static bool already_instantiated;
	public:
		Display(char *title = "Angel Wars");
		~Display();
		bool set_mode(int x, int y, int color_depth);
		int get_width();
		int get_height();
		int get_color_depth();
		
		void bind_cache(ImageCache *new_cache);

		void paint_sprite(int x, int y, char *tag, ImageCache::node *hash = NULL);
		BoundingBox get_sprite_dimensions(char *tag);

		void start_new_frame();
		void paint_current_frame();
		
		ImageCache::node *get_hash_node(char *tag);
		
		SDL_Surface *get_buffer();
};



#endif

