
#include "enemy-fatboy.h"



EnemyFatboy::EnemyFatboy()
{
 	type = "EnemyFatboy";

 	has_dropped_pitchfork = false;
 	needs_to_fire = false;
 	
	Anim *fat_anim = new Anim;
	Anim *fat_dies = new Anim;
	fat_anim->set_looping(true);
	fat_dies->set_looping(false);
	fat_anim->add_frame("fatdemon00", 1);
	fat_anim->add_hash();
	fat_dies->add_frame("fatdemondeath00", 4);
	fat_dies->add_frame("fatdemondeath01", 4);
	fat_dies->add_frame("fatdemondeath02", 4);
	fat_dies->add_frame("fatdemondeath03", 4);
	fat_dies->add_frame("fatdemondeath04", 4);
	fat_dies->add_frame("fatdemondeath05", 4);
	fat_dies->add_frame("fatdemondeath06", 4);
	fat_dies->add_frame("fatdemondeath07", 4);
	fat_dies->add_frame("fatdemonskeleton00", 32000);
	fat_dies->add_hash();
	wings_anim = new Anim;
	wings_anim->add_frame("fatwings00", 8);
	wings_anim->add_frame("fatwings01", 4);
	wings_anim->add_frame("fatwings02", 8);
	wings_anim->add_frame("fatwings00", 4);
	wings_anim->set_looping(true);
	wings_anim->add_hash();
	fire_anim = new Anim;
	fire_anim->add_frame("fatdemon03", 4);
	fire_anim->add_frame("fatdemon01", 4);
	fire_anim->add_frame("fatdemon02", 4);
	fire_anim->add_frame("fatdemon03", 4);
	fire_anim->set_looping(false);
	fire_anim->add_hash();
	set_collision_damage(2);
	set_hp(125);
	set_damage_types(true, false);
	set_hurt_types(false, true);
	BehaviorQuadratic *be_death = new BehaviorQuadratic;
	be_death->set_dx(-2);
	be_death->set_d2y(-.1);
	set_death_behavior(be_death);
	set_idle_anim(fat_anim);
	set_death_anim(fat_dies);
	set_anim(fat_anim);
	set_scope(-60, -80, get_display()->get_width() + 80,
	get_display()->get_height() + 80);
	set_death_on_leaving_scope(true);
	set_point_value(250);
}



EnemyFatboy::~EnemyFatboy()
{
	delete wings_anim;
}



Actor::ActorSignal EnemyFatboy::update()
{
	ActorSignal retsignal = {"", this};
	int temp_x, temp_y;
	char *rec_sig;

	//if (get_hp() > 0) set_anim(get_idle_anim());
	if (get_hp() <= 0) {
		if (strcmp(get_anim()->get_current_frame(), "fatdemondeath00") == 0)
			if (has_dropped_pitchfork == false) {
				drop_pitchfork();
				has_dropped_pitchfork = true;
			}
		if (strcmp(get_anim()->get_current_frame(), "fatdemondeath04") == 0)
			if (get_death_behavior() != NULL) {
				if (get_behavior() != NULL) delete get_behavior();
					set_behavior(get_death_behavior());
					set_death_behavior(NULL);
			}
		dead = true;
		set_anim(get_death_anim());
		if (get_death_anim()->at_end()) {
			retsignal.signal = "suicide";
			retsignal.source = this;
		}
	}
	if (get_death_on_leaving_scope() && !get_scope().contains(get_bounding_box())) {
		retsignal.signal = "suicide";
		retsignal.source = this;
	}
	wings_anim->update();
	if (get_behavior() != NULL) rec_sig = get_behavior()->update(temp_x, temp_y);
	set_position(temp_x, temp_y);
	fire_pitchfork(rec_sig);
	if (get_anim() != NULL) {
		get_anim()->update();
	}
	return retsignal;
}



// Tell the display to paint the fatboy
void EnemyFatboy::paint()
{
	if (get_display() == NULL) {
		std::cerr << "WARNING: tried to paint an ActorPlayer before display bound" << std::endl;
	} else if (get_anim() == NULL) {
		std::cerr << "WARNING: tried to paint an ActorPlayer without an anim" << std::endl;
	} else {
		get_display()->paint_sprite(get_x(), get_y(), get_anim()->get_current_frame());
		get_display()->paint_sprite(get_x(), get_y(), wings_anim->get_current_frame());
	}
}




void EnemyFatboy::drop_pitchfork()
{
	Actor *pitchfork = new Actor;
	BehaviorQuadratic *be = new BehaviorQuadratic;
	be->set_position(get_x(), get_y());
	be->set_d2y(.4);
	be->set_dx(1);
	pitchfork->set_position(get_x(), get_y());
	pitchfork->set_z(get_z());
	Anim *pitch_anim = new Anim;
	pitch_anim->set_looping(true);
	pitch_anim->add_frame("pitchfork00", 0);
	pitch_anim->add_hash();
	pitchfork->set_scope(-35, -25, get_display()->get_width() + 35,
		get_display()->get_height() + 25);
	pitchfork->set_death_on_leaving_scope(true);
	pitchfork->set_behavior(be);
	pitchfork->set_anim(pitch_anim);
	get_actorlist()->add_actor(pitchfork);
}



void EnemyFatboy::fire_pitchfork(char *rec_sig)
{
	if (!dead) {
		if ((get_anim() == fire_anim) && (fire_anim->at_end()))
			set_anim(get_idle_anim());
		if (strcmp(rec_sig, "fire") == 0) {
			fire_anim->reset();
			set_anim(fire_anim);
			needs_to_fire = true;
		}
		if ((get_anim() == fire_anim) && (strcmp(fire_anim->get_current_frame(), "fatdemon02") == 0) && (needs_to_fire == true)) {
			needs_to_fire = false;
			BehaviorLinear *be = new BehaviorLinear;
			Behavior *be_d = new Behavior;
			be->set_dx(-7);
			Enemy *shot = new Enemy;
			Anim *shot_anim = new Anim;
			Anim *shot_d_anim = new Anim;
			shot_anim->set_looping(true);
			shot_d_anim->set_looping(false);
			shot_anim->add_frame("pitchforkshot00", 8);
			shot_anim->add_frame("pitchforkshot01", 8);
			shot_anim->add_frame("pitchforkshot02", 8);
			shot_anim->add_hash();
			shot_d_anim->add_frame("pitchforkpuff00", 3);
			shot_d_anim->add_frame("pitchforkpuff01", 3);
			shot_d_anim->add_frame("pitchforkpuff02", 3);
			shot_d_anim->add_frame("pitchforkpuff03", 3);
			shot_d_anim->add_hash();
			shot->set_death_behavior(be_d);
			
			shot->set_idle_anim(shot_anim);
			shot->set_death_anim(shot_d_anim);
			//shot->set_anim(shot_anim);
			shot->set_position(get_x(), get_y() + 7);
		
			shot->set_collision_damage(25);
			shot->set_hp(2);
			shot->set_damage_types(true, false);
			shot->set_hurt_types(false, true);
			
			shot->set_behavior(be);
			shot->set_point_value(5);
		
			shot->set_scope(-15, -25, get_display()->get_width() + 25,
				get_display()->get_height() + 25);
			shot->set_death_on_leaving_scope(true);
			
			get_actorlist()->add_actor(shot);	
		}
	}
}

