
#include "enemy.h"

Enemy::Enemy()
{
	point_value = 0;
	type = "Enemy";
}



Enemy::~Enemy()
{
	if (strcmp(type, "Enemy") == 0) {
		if (get_idle_anim() != NULL)
			delete get_idle_anim();
		if (get_death_anim() != NULL)
			delete get_death_anim();
		if (get_behavior() != NULL)
			delete get_behavior();
		if (get_death_behavior() != NULL)
			delete get_death_behavior();
	}
}



void Enemy::get_signal(ActorSignal signal)
{
	Actor::ActorSignal response = {"", this};

	if ((strcmp(signal.signal, "hurt") == 0) && !dead)
		if (signal.source->damages_players() && gets_hurt_as_player()) {
			hurt(signal.source->get_collision_damage());
			if (get_hp() <= 0) {
				response.signal = "enemy_killed";
				signal.source->get_signal(response);
				dead = true;
			}
		} else if (signal.source->damages_enemies() && gets_hurt_as_enemy()) {
			hurt(signal.source->get_collision_damage());
			if (get_hp() <= 0) {
				response.signal = "enemy_killed";
				signal.source->get_signal(response);
				dead = true;
			}
		}		
}



void Enemy::set_point_value(int value)
{
	point_value = value;
}



int Enemy::get_point_value()
{
	return point_value;
}

