
#include "event.h"



Event::Event()
{
	button = -1;
	kill = false;
	clear_keyarray();
	SDL_EnableKeyRepeat(1, SDL_DEFAULT_REPEAT_INTERVAL);
	SDL_EventState(SDL_KEYDOWN, SDL_IGNORE);
}



Event::~Event()
{
}



void Event::poll()
{
	SDL_Event event;
	
	int key_counter;
	
	button = -1;
	kill = false;
	
	clear_keyarray();
	
	SDL_PumpEvents();
	
	SDL_GetKeyState(&numkeys);

		for (key_counter = 0; key_counter < numkeys; key_counter++)
			if ((int)SDL_GetKeyState(&numkeys)[key_counter] == 1)
				keys[keycode_convert(key_counter)] = true;
	
	while (SDL_PollEvent(&event) == 1) {
		switch (event.type) {
			case (SDL_MOUSEBUTTONDOWN):
				button = buttoncode_convert(event.button.button);
				break;
			case (SDL_QUIT):
				kill = true;
				break;
		}
	}
}



bool *Event::key()
{
	return keys;
}



int Event::buttonclicked()
{
	return button;
}



bool Event::killprogram()
{
	return kill;
}



int Event::keycode_convert(int keysym)
{
	switch (keysym) {
		case (SDLK_RETURN):
			return KEY_ENTER; break;
		case (SDLK_UP):
			return KEY_UP; break;
		case (SDLK_DOWN):
			return KEY_DOWN; break;
		case (SDLK_LEFT):
			return KEY_LEFT; break;
		case (SDLK_RIGHT):
			return KEY_RIGHT; break;
		case (SDLK_SPACE):
			return KEY_SPACE; break;
		case (SDLK_ESCAPE):
			return KEY_ESCAPE; break;
		case (SDLK_LCTRL):
			return KEY_LCTRL; break;
		case (SDLK_RCTRL):
			return KEY_RCTRL; break;
		case (SDLK_COMMA):
			return KEY_COMMA; break;
		case (SDLK_PERIOD):
			return KEY_PERIOD; break;
		case (SDLK_LSHIFT):
			return KEY_LSHIFT; break;
		case (SDLK_RSHIFT):
			return KEY_RSHIFT; break;
		case (SDLK_PAUSE):
			return KEY_PAUSE; break;
		default:
			return KEY_NONE;
	}
}



int Event::buttoncode_convert(int button)
{
	if (button == 3) button = 2;
	else if (button == 2) button = 3;
	return button;
}



void Event::clear_keyarray()
{
	int counter;
	
	for (counter = 0; counter < EVENT_NUM_KEYS; counter++)
		keys[counter] = false;
}

