/***************************************************************************
                                 event.h
                             -------------------
    begin                : Fri May 26 2000
    copyright            : (C) 2000 by Bytopia Software
    email                : lancekt@wam.umd.edu
                             -------------------
	Event (input) handler.  This is internally platform-dependent; the
	interface is platform-independent.  This version uses SDL.
 ***************************************************************************/

#ifndef EVENT_H
#define EVENT_H

#define EVENT_NUM_KEYS 256

#include <iostream>
#include <SDL/SDL.h>



enum keys {
	KEY_NONE,
	KEY_Z,
	KEY_ENTER, KEY_ESCAPE,
	KEY_LEFT, KEY_RIGHT, KEY_UP, KEY_DOWN,
	KEY_SPACE,
	KEY_LCTRL, KEY_RCTRL,
	KEY_COMMA, KEY_PERIOD,
	KEY_LSHIFT, KEY_RSHIFT,
	KEY_PAUSE
};



class Event {
	private:
		int button;
		int numkeys;
		bool kill;
		bool keys[EVENT_NUM_KEYS];
	public:
		Event();
		~Event();
		
		void poll();
		
	 	bool *key();
		int buttonclicked();
		bool killprogram();
	private:
		void clear_keyarray();
		int keycode_convert(int keysym);
		int buttoncode_convert(int button);
};



#endif

