#include "main-menu.h"

volatile int menu_update_count = 1;

Uint32 menu_callback(Uint32 interval)
{
	menu_update_count++;
	return 20;
}


menu_result_t show_menu(Display *display)
{
	SDL_Surface *menu_image = IMG_Load("/usr/share/games/angelwars/images/menus/mainmenu.jpg");
	if (menu_image == NULL) {
		std::cerr << "FATAL: unable to load menu image" << std::endl;
		std::cerr << "Did you get the angelwars-media package?" << std::endl;
		exit(0);
	}
	menu_result_t result = menu_result_none;
	int pos = menu_result_play;
	int to_next_sel = 0;
	ActorList list;
	ImageCache cache;
	display->bind_cache(&cache);
	cache.load_images_from_list_file("/usr/share/games/angelwars/images/lightning.txt");
  BulletLightning *lgt = new BulletLightning;
  Behavior *be = new Behavior;
  delete lgt->get_behavior();
  lgt->set_behavior(be);
  list.add_actor(lgt);
  BulletLightning *lgt2 = new BulletLightning;
  be = new Behavior;
  delete lgt2->get_behavior();
  lgt2->set_behavior(be);
  list.add_actor(lgt2);
  lgt->update();
  lgt->update();
  lgt->update();
  lgt->update();
  		
	Event handler;
	
	SDL_SetTimer(20, menu_callback);
	
	while (result == menu_result_none) {
		while (menu_update_count > 0) {
			handler.poll();
			menu_update_count--;
			if (to_next_sel > 0) to_next_sel--;
			if (handler.killprogram()) result = menu_result_quit;
			if (handler.key()[KEY_DOWN])
				if (to_next_sel == 0) {
					to_next_sel = 7;
					pos++;
					if (pos > menu_result_quit) pos = menu_result_quit;
				}
			if (handler.key()[KEY_UP])
				if (to_next_sel == 0) {
					to_next_sel = 7;
					pos--;
					if (pos < menu_result_play) pos = menu_result_play;
				}
			if (handler.key()[KEY_ENTER])
				result = (menu_result_t)pos;
			list.update();
			switch (pos) {
				case menu_result_play:
					lgt->set_position(60, 95);
					lgt2->set_position(220, 95);
					break;
				case menu_result_load:
					lgt->set_position(65, 125);
					lgt2->set_position(215, 125);
					break;
				case menu_result_options:
					lgt->set_position(80, 165);
					lgt2->set_position(200, 165);
					break;
				case menu_result_quit:
					lgt->set_position(105, 200);
					lgt2->set_position(177, 200);
					break;
			}
		}
		display->start_new_frame();
		SDL_BlitSurface(menu_image, NULL, display->get_buffer(), NULL);
		list.paint();
		display->paint_current_frame();
	}
	
	return result;

}

