
#include "mixer.h"



bool Mixer::already_instantiated = false;



Mixer::Mixer()
{
	if (already_instantiated) {
		std::cerr << "FATAL: tried to open multiple mixers" << std::endl;
		exit(0);
	}
	already_instantiated = true;

	cache = NULL;

 	SDL_Init(SDL_INIT_AUDIO);
  Mix_OpenAudio(MIX_DEFAULT_FREQUENCY, MIX_DEFAULT_FORMAT, MIX_DEFAULT_CHANNELS, 256);
  Mix_AllocateChannels(8);
}



Mixer::~Mixer()
{
	Mix_CloseAudio();
}



void Mixer::bind_cache(AudioCache *new_cache)
{
	cache = new_cache;
}



void Mixer::play_sound(char *tag, int volume)
{
	Mix_Chunk *chunk;
	if (cache != NULL) {
		chunk = cache->get_sound(tag);
		Mix_VolumeChunk(chunk, volume);
		Mix_PlayChannel(-1, chunk, 0);
	}
}

